"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = __importStar(require("fs"));
var util = __importStar(require("util"));
var _ = __importStar(require("underscore"));
var gm_1 = __importDefault(require("gm"));
var ck_lib_1 = require("@ckstack/ck-lib");
var MyValues_1 = require("./MyValues");
var CkFileUtils = (function () {
    function CkFileUtils() {
    }
    CkFileUtils.init = function () {
        ck_lib_1.CkLogger.infoLog2('CkFileUtils.init', MyValues_1.PROC_LHD.IP_LHD_HTTP);
    };
    CkFileUtils.__crop = function (src, dest, width, height, x, y, reqIpAndLhdAndHttpInfo, lang) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, new Promise(function (resolve, reject) {
                        var lhd = reqIpAndLhdAndHttpInfo || ck_lib_1.CkValue.getDefaultLogKey(true);
                        if (width === undefined || width === 0) {
                            ck_lib_1.CkLogger.errLog2("can't resize image (crop). no w value. w [".concat(width, "]"), lhd);
                            reject(new ck_lib_1.CkError(lhd, ck_lib_1.CKERROR_CODES.wrong_request.name, 400, undefined, lang));
                            return;
                        }
                        if (height === undefined || height === 0) {
                            ck_lib_1.CkLogger.errLog2("can't resize image (crop). no h value. h [".concat(height, "]"), lhd);
                            reject(new ck_lib_1.CkError(lhd, ck_lib_1.CKERROR_CODES.wrong_request.name, 400, undefined, lang));
                            return;
                        }
                        (0, gm_1.default)(src).crop(width, height, x, y)
                            .write(dest, function (err) {
                            if (err) {
                                ck_lib_1.CkLogger.errLog2("crop image. src path [".concat(src, "], dest path [").concat(dest, "], width [").concat(width, "], height [").concat(height, "], x [").concat(x, "], y [").concat(y, "], err [").concat(err.toString(), "]"), lhd);
                                reject(new ck_lib_1.CkError(lhd, ck_lib_1.CKERROR_CODES.use_filesystem.name, 500, undefined, lang));
                                return;
                            }
                            ck_lib_1.CkLogger.infoLog2("crop image. src path [".concat(src, "], dest path [").concat(dest, "], width [").concat(width, "], height [").concat(height, "], x [").concat(x, "], y [").concat(y, "]"), lhd);
                            resolve();
                        });
                    })];
            });
        });
    };
    CkFileUtils.__resize = function (src, dest, width, height, isForceSize, reqIpAndLhdAndHttpInfo, lang) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, new Promise(function (resolve, reject) {
                        var lhd = reqIpAndLhdAndHttpInfo || ck_lib_1.CkValue.getDefaultLogKey(true);
                        if (!height) {
                            (0, gm_1.default)(src).resize(width)
                                .write(dest, function (err) {
                                if (err) {
                                    ck_lib_1.CkLogger.errLog2("resize image only have width. src path [".concat(src, "], dest path [").concat(dest, "], width [").concat(width, "], height [").concat(height, "], err [").concat(err.toString(), "]"), lhd);
                                    reject(new ck_lib_1.CkError(lhd, ck_lib_1.CKERROR_CODES.use_filesystem.name, 500, undefined, lang));
                                    return;
                                }
                                ck_lib_1.CkLogger.infoLog2("resize image only have width. src path [".concat(src, "], dest path [").concat(dest, "], width [").concat(width, "], height [").concat(height, "]"), lhd);
                                resolve();
                            });
                            return;
                        }
                        if (isForceSize) {
                            (0, gm_1.default)(src).resize(width, height, '!')
                                .write(dest, function (err) {
                                if (err) {
                                    ck_lib_1.CkLogger.errLog2("resize image force size. src path [".concat(src, "], dest path [").concat(dest, "], width [").concat(width, "], height [").concat(height, "], err [").concat(err.toString(), "]"), lhd);
                                    reject(new ck_lib_1.CkError(lhd, ck_lib_1.CKERROR_CODES.use_filesystem.name, 500, undefined, lang));
                                    return;
                                }
                                ck_lib_1.CkLogger.infoLog2("resize image force size. src path [".concat(src, "], dest path [").concat(dest, "], width [").concat(width, "], height [").concat(height, "]"), lhd);
                                resolve();
                            });
                            return;
                        }
                        (0, gm_1.default)(src).resize(width, height)
                            .write(dest, function (err) {
                            if (err) {
                                ck_lib_1.CkLogger.errLog2("resize image. src path [".concat(src, "], dest path [").concat(dest, "], width [").concat(width, "], height [").concat(height, "], err [").concat(err.toString(), "]"), lhd);
                                reject(new ck_lib_1.CkError(lhd, ck_lib_1.CKERROR_CODES.use_filesystem.name, 500, undefined, lang));
                                return;
                            }
                            ck_lib_1.CkLogger.infoLog2("resize image. src path [".concat(src, "], dest path [").concat(dest, "], width [").concat(width, "], height [").concat(height, "]"), lhd);
                            resolve();
                        });
                    })];
            });
        });
    };
    CkFileUtils.readAsyncFileToBuffer = function (reqIpAndLhdAndHttpInfo, filePath, lang) {
        var lhd = reqIpAndLhdAndHttpInfo || ck_lib_1.CkValue.getDefaultLogKey(true);
        var readFile = util.promisify(fs.readFile);
        var ret = null;
        try {
            ret = readFile(filePath);
            ck_lib_1.CkLogger.debugLog2("success read file. src file path [".concat(filePath, "]"), lhd);
        }
        catch (err) {
            ck_lib_1.CkLogger.errLog2("can't read file. src file path [".concat(filePath, "]. err [").concat(err.toString(), "]"), lhd);
            throw new ck_lib_1.CkError(lhd, ck_lib_1.CKERROR_CODES.use_filesystem.name, 500, undefined, lang);
        }
        return ret;
    };
    CkFileUtils.writeAsyncBufferToFile = function (reqIpAndLhdAndHttpInfo, srcBuffer, destFilePath, opt, lang) {
        var lhd = reqIpAndLhdAndHttpInfo || ck_lib_1.CkValue.getDefaultLogKey(true);
        try {
            fs.writeFileSync(destFilePath, srcBuffer, opt);
            ck_lib_1.CkLogger.debugLog2("success write file. dest file path [".concat(destFilePath, "]"), lhd);
        }
        catch (err) {
            ck_lib_1.CkLogger.errLog2("can't write file. dest file path [".concat(destFilePath, "]"), lhd);
            throw new ck_lib_1.CkError(lhd, ck_lib_1.CKERROR_CODES.use_filesystem.name, 500, undefined, lang);
        }
    };
    CkFileUtils.mkdirs = function (dir, reqIpAndLhdAndHttpInfo) {
        var lhd = reqIpAndLhdAndHttpInfo || ck_lib_1.CkValue.getDefaultLogKey(true);
        var dirs = dir.split('/');
        var _dir = '';
        _.each(dirs, function (element) {
            var _element = element.trim();
            if (_element.length <= 0) {
                return;
            }
            _dir += ("/".concat(_element));
            if (!fs.existsSync(_dir)) {
                fs.mkdirSync(_dir, 509);
                ck_lib_1.CkLogger.debugLog2("mkdir [".concat(_dir, "]"), lhd);
            }
        });
    };
    CkFileUtils.removeFileOrDirectory = function (filePath, reqIpAndLhdAndHttpInfo, lang) {
        var lhd = reqIpAndLhdAndHttpInfo || ck_lib_1.CkValue.getDefaultLogKey(true);
        if (!fs.existsSync(filePath)) {
            ck_lib_1.CkLogger.debugLog2("already removed file [".concat(filePath, "]"), lhd);
            return;
        }
        if (fs.lstatSync(filePath).isDirectory()) {
            try {
                fs.rmdirSync(filePath, { recursive: true });
                ck_lib_1.CkLogger.debugLog2("removed file(directory) [".concat(filePath, "]"), lhd);
            }
            catch (err) {
                ck_lib_1.CkLogger.errLog2("failed remove file(directory) [".concat(filePath, "]. err [").concat(err.toString(), "]"), lhd);
                throw new ck_lib_1.CkError(lhd, ck_lib_1.CKERROR_CODES.use_filesystem.name, 500, undefined, lang);
            }
            return;
        }
        try {
            fs.unlinkSync(filePath);
            ck_lib_1.CkLogger.debugLog2("removed file [".concat(filePath, "]"), lhd);
        }
        catch (err) {
            ck_lib_1.CkLogger.errLog2("failed remove file [".concat(filePath, "]. err [").concat(err.toString(), "]"), lhd);
            throw new ck_lib_1.CkError(lhd, ck_lib_1.CKERROR_CODES.use_filesystem.name, 500, undefined, lang);
        }
    };
    CkFileUtils.copy = function (src, dest, reqIpAndLhdAndHttpInfo, lang) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, new Promise(function (resolve, reject) {
                        var lhd = reqIpAndLhdAndHttpInfo || ck_lib_1.CkValue.getDefaultLogKey(true);
                        var read = fs.createReadStream(src);
                        var write = fs.createWriteStream(dest);
                        read.on('error', function (err) {
                            ck_lib_1.CkLogger.errLog2("read file for copy. src path [".concat(src, "]. err [").concat(err.toString(), "]"), lhd);
                            reject(new ck_lib_1.CkError(lhd, ck_lib_1.CKERROR_CODES.use_filesystem.name, 500, undefined, lang));
                        });
                        write.on('error', function (err) {
                            ck_lib_1.CkLogger.errLog2("write file for copy. src path [".concat(src, "], dest path [").concat(dest, "]. err [").concat(err.toString(), "]"), lhd);
                            reject(new ck_lib_1.CkError(lhd, ck_lib_1.CKERROR_CODES.use_filesystem.name, 500, undefined, lang));
                        });
                        write.on('close', function () {
                            ck_lib_1.CkLogger.debugLog2("copy file complete. src path [".concat(src, "], dest path [").concat(dest, "]"), lhd);
                            resolve(dest);
                        });
                        read.pipe(write);
                    })];
            });
        });
    };
    CkFileUtils.getFileSize = function (filePath, reqIpAndLhdAndHttpInfo, lang) {
        var lhd = reqIpAndLhdAndHttpInfo || ck_lib_1.CkValue.getDefaultLogKey(true);
        var stats;
        try {
            stats = fs.statSync(filePath);
        }
        catch (err) {
            ck_lib_1.CkLogger.debugLog2("can't get file info. file path [".concat(filePath, "]. err [").concat(err.toString(), "]"), lhd);
            throw new ck_lib_1.CkError(lhd, ck_lib_1.CKERROR_CODES.use_filesystem.name, 500, undefined, lang);
        }
        if (stats === undefined || stats === null || Number.isNaN(stats) || stats.size === undefined
            || stats.size === null || Number.isNaN(stats.size)) {
            ck_lib_1.CkLogger.warnLog2("can't get file size. file size set zero. file path [".concat(filePath, "]"), lhd);
            return 0;
        }
        return stats.size;
    };
    CkFileUtils.getImageFileResolution = function (filePath, reqIpAndLhdAndHttpInfo, lang) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, new Promise(function (resolve, reject) {
                        (0, gm_1.default)(filePath).size(function (err, sz) {
                            var lhd = reqIpAndLhdAndHttpInfo || ck_lib_1.CkValue.getDefaultLogKey(true);
                            if (err) {
                                ck_lib_1.CkLogger.errLog2("get image size. file path [".concat(filePath, "]. err [").concat(err.toString(), "]"), lhd);
                                reject(new ck_lib_1.CkError(lhd, ck_lib_1.CKERROR_CODES.use_filesystem.name, 500, undefined, lang));
                                return;
                            }
                            ck_lib_1.CkLogger.debugLog2("get image size. file path [".concat(filePath, "], width [").concat(sz.width, "], height [").concat(sz.height, "]"), lhd);
                            resolve(sz);
                        });
                    })];
            });
        });
    };
    CkFileUtils.resizeImage = function (src, dest, mode, opt, reqIpAndLhdAndHttpInfo, lang) {
        return __awaiter(this, void 0, void 0, function () {
            var lhd, resol;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        lhd = reqIpAndLhdAndHttpInfo || ck_lib_1.CkValue.getDefaultLogKey(true);
                        return [4, CkFileUtils.getImageFileResolution(src, lhd, lang)];
                    case 1:
                        resol = _a.sent();
                        if (!(mode === ck_lib_1.CkValue.IMAGE_RESIZE_MODE.CROP)) return [3, 3];
                        return [4, CkFileUtils.__crop(src, dest, opt.w, opt.h, opt.x, opt.y, lhd, lang)];
                    case 2:
                        _a.sent();
                        return [2, dest];
                    case 3:
                        if (!(mode === ck_lib_1.CkValue.IMAGE_RESIZE_MODE.RESIZE)) return [3, 11];
                        if (!(opt.h === undefined || opt.h === null || Number.isNaN(opt.h) || opt.h <= 0)) return [3, 5];
                        if (opt.w !== 0 && !opt.w) {
                            ck_lib_1.CkLogger.errLog2("can't resize image (resize). no w value for resize width. w [".concat(opt.w, "]"), lhd);
                            throw new ck_lib_1.CkError(lhd, ck_lib_1.CKERROR_CODES.wrong_request.name, 400, undefined, lang);
                        }
                        return [4, CkFileUtils.__resize(src, dest, opt.w, undefined, false, lhd, lang)];
                    case 4:
                        _a.sent();
                        return [2, dest];
                    case 5:
                        if (!(opt.w === undefined || opt.w === null || Number.isNaN(opt.w) || opt.w <= 0)) return [3, 7];
                        return [4, CkFileUtils.__resize(src, dest, resol.width, opt.h, false, lhd, lang)];
                    case 6:
                        _a.sent();
                        return [2, dest];
                    case 7:
                        if (!(opt.r !== undefined && opt.r !== null && !Number.isNaN(opt.r) && opt.r)) return [3, 9];
                        return [4, CkFileUtils.__resize(src, dest, opt.w, opt.h, false, lhd, lang)];
                    case 8:
                        _a.sent();
                        return [2, dest];
                    case 9: return [4, CkFileUtils.__resize(src, dest, opt.w, opt.h, true, lhd, lang)];
                    case 10:
                        _a.sent();
                        return [2, dest];
                    case 11:
                        ck_lib_1.CkLogger.warnLog2("unknown resize mode. mode [".concat(mode, "]"), lhd);
                        throw new ck_lib_1.CkError(lhd, ck_lib_1.CKERROR_CODES.wrong_request.name, 400, undefined, lang);
                }
            });
        });
    };
    return CkFileUtils;
}());
exports.default = CkFileUtils;
